commit ceb563444afa8c5a57d5305c8849d554c1112dc3
Author: freddy77 <freddy77>
Date:   Sat Aug 16 18:08:22 2008 +0000

    do not loose sync on conversion errors

diff --git a/ChangeLog b/ChangeLog
index 1c9d6a7..2a71736 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Aug 16 20:08:03 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/query.c: do not loose sync on conversion errors
+
 Sat Aug 16 16:47:21 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c src/odbc/odbc_util.c src/odbc/sql2tds.c:
 	- allow SQL_WCHAR/SQL_WVARCHAR
@@ -545,4 +548,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2585 2008/08/16 14:48:57 freddy77 Exp $
+$Id: ChangeLog,v 1.2586 2008/08/16 18:08:22 freddy77 Exp $
diff --git a/src/tds/query.c b/src/tds/query.c
index 128a441..d435f73 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.222 2008/07/16 13:58:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.223 2008/08/16 18:08:22 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -388,6 +388,7 @@ tds_submit_query_params(TDSSOCKET * tds, const char *query, TDSPARAMINFO * param
 			param = params->columns[i];
 			/* TODO check error */
 			tds_put_data_info(tds, param, 0);
+			/* FIXME handle error */
 			tds_put_data(tds, param);
 		}
 		tds->internal_sp_called = TDS_SP_EXECUTESQL;
@@ -1197,6 +1198,7 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 			param = params->columns[i];
 			/* TODO check error */
 			tds_put_data_info(tds, param, 0);
+			/* FIXME handle error */
 			tds_put_data(tds, param);
 		}
 
@@ -1468,13 +1470,14 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 #endif
 			/* we need to convert data before */
 			/* TODO this can be a waste of memory... */
+			converted = 1;
 			s = tds_convert_string(tds, curcol->char_conv, s, colsize, &colsize);
 			if (!s) {
-				/* FIXME this is a bad place to return error... */
+				/* on conversion error put a empty string */
 				/* TODO on memory failure we should compute converted size and use chunks */
-				return TDS_FAIL;
+				colsize = 0;
+				converted = -1;
 			}
-			converted = 1;
 		}
 			
 		switch (curcol->column_varint_size) {
@@ -1500,6 +1503,10 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			break;
 		}
 
+		/* conversion error, exit with an error */
+		if (converted < 0)
+			return TDS_FAIL;
+
 		/* put real data */
 		if (is_numeric_type(curcol->on_server.column_type)) {
 			TDS_NUMERIC buf;
@@ -1607,6 +1614,7 @@ tds7_send_execute(TDSSOCKET * tds, TDSDYNAMIC * dyn)
 			param = info->columns[i];
 			/* TODO check error */
 			tds_put_data_info(tds, param, 0);
+			/* FIXME handle error */
 			tds_put_data(tds, param);
 		}
 
@@ -1706,7 +1714,7 @@ tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags)
 	/* row data */
 	tds_put_byte(tds, TDS5_PARAMS_TOKEN);
 	for (i = 0; i < info->num_cols; i++) {
-		/* TODO check error */
+		/* FIXME handle error */
 		tds_put_data(tds, info->columns[i]);
 	}
 }
@@ -1879,6 +1887,7 @@ tds_submit_rpc(TDSSOCKET * tds, const char *rpc_name, TDSPARAMINFO * params)
 			param = params->columns[i];
 			/* TODO check error */
 			tds_put_data_info(tds, param, TDS_PUT_DATA_USE_NAME);
+			/* FIXME handle error */
 			tds_put_data(tds, param);
 		}
 
@@ -2222,6 +2231,7 @@ tds_cursor_open(TDSSOCKET * tds, TDSCURSOR * cursor, TDSPARAMINFO *params, int *
 				TDSCOLUMN *param = params->columns[i];
 				/* TODO check error */
 				tds_put_data_info(tds, param, 0);
+				/* FIXME handle error */
 				tds_put_data(tds, param);
 			}
 		}
@@ -2776,6 +2786,7 @@ tds_cursor_update(TDSSOCKET * tds, TDSCURSOR * cursor, TDS_CURSOR_OPERATION op,
 				param = params->columns[n];
 				/* TODO check error */
 				tds_put_data_info(tds, param, TDS_PUT_DATA_USE_NAME|TDS_PUT_DATA_PREFIX_NAME);
+				/* FIXME handle error */
 				tds_put_data(tds, param);
 			}
 		}

